## kwin 5.15.11.27

=== debian/changelog ===
kwin (4:5.15.11.27-1) unstable; urgency=medium

  * update

 -- Debian/Kubuntu Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>  Wed, 15 Jun 2022 11:27:19 +0800

=== debian/control ===
Source: kwin
Section: kde
Priority: optional
Maintainer: Debian/Kubuntu Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Maximiliano Curia <maxy@debian.org>
Build-Depends: breeze-dev (>= 4:5.9.0~),
               cmake (>= 3.1~),
               debhelper (>= 11~),
               extra-cmake-modules (>= 5.38~),
               kinit-dev (>= 5.42.0~),
               kscreenlocker-dev,
               libcap-dev [linux-any],
               libdbusmenu-qt5-2,
               libdrm-dev (>= 2.4.62~),
               libegl1-mesa-dev (>= 1.2~),
               libepoxy-dev (>= 1.2),
               libfontconfig1-dev,
               libfreetype6-dev,
               libgbm-dev,
               libice-dev,
               libinput-dev (>= 1.9~),
               libkdecorations2-dev (>= 4:5.13),
               libkf5activities-dev (>= 5.42.0~),
               libkf5completion-dev (>= 5.42.0~),
               libkf5config-dev (>= 5.42.0~),
               libkf5configwidgets-dev (>= 5.42.0~),
               libkf5coreaddons-dev (>= 5.42.0~),
               libkf5crash-dev (>= 5.42.0~),
               libkf5declarative-dev (>= 5.42.0~),
               libkf5doctools-dev (>= 5.42.0~),
               libkf5globalaccel-dev (>= 5.42.0~),
               libkf5i18n-dev (>= 5.42.0~),
               libkf5iconthemes-dev (>= 5.42.0~),
               libkf5idletime-dev (>= 5.42.0~),
               libkf5kcmutils-dev (>= 5.42.0~),
               libkf5kio-dev (>= 5.42.0~),
               libkf5newstuff-dev (>= 5.42.0~),
               libkf5notifications-dev (>= 5.42.0~),
               libkf5package-dev (>= 5.42.0~),
               libkf5plasma-dev (>= 5.42.0~),
               libkf5service-dev (>= 5.42.0~),
               libkf5textwidgets-dev (>= 5.42.0~),
               libkf5wayland-dev (>= 4:5.57.0.11~),
               libkf5widgetsaddons-dev (>= 5.42.0~),
               libkf5windowsystem-dev (>= 5.42.0~),
               libkf5xmlgui-dev (>= 5.42.0~),
               libphonon4qt5-4,
               libqt5sensors5-dev (>= 5.11.0~),
               libqt5x11extras5-dev (>= 5.11.0~),
               libsm-dev,
               libudev-dev [linux-any],
               libwayland-dev (>= 1.2),
               libx11-xcb-dev,
               libxcb-composite0-dev (>= 1.10~),
               libxcb-cursor-dev,
               libxcb-damage0-dev (>= 1.10~),
               libxcb-glx0-dev (>= 1.10~),
               libxcb-icccm4-dev,
               libxcb-image0-dev,
               libxcb-keysyms1-dev,
               libxcb-randr0-dev (>= 1.10~),
               libxcb-render0-dev (>= 1.10~),
               libxcb-shape0-dev (>= 1.10~),
               libxcb-shm0-dev (>= 1.10~),
               libxcb-sync-dev (>= 1.10~),
               libxcb-xfixes0-dev (>= 1.10~),
               libxcb-xtest0-dev,
               libxcb1-dev (>= 1.10~),
               libxcursor-dev,
               libxi-dev,
               libxkbcommon-dev (>= 0.7.0~),
               pkg-config,
               pkg-kde-tools (>= 0.15.18~),
               qtbase5-dev (>= 5.11.0~),
               qtbase5-private-dev (>= 5.7.0~),
               qtdeclarative5-dev (>= 5.11.0~),
               qtscript5-dev (>= 5.11.0~),
               qttools5-dev (>= 5.11.0~),
               systemtap-sdt-dev,
               libpipewire-0.3-dev,
               libxcb-util0-dev,
               libxtst-dev,
               libgsettings-qt-dev,
Standards-Version: 4.1.4
Homepage: https://projects.kde.org/projects/kde/workspace/kwin
Vcs-Browser: https://salsa.debian.org/qt-kde-team/kde/kwin
Vcs-Git: https://salsa.debian.org/qt-kde-team/kde/kwin.git

Package: kwin-common
Architecture: any
Depends: kwin-data (= ${source:Version}),
         libkf5globalaccel-bin,
         libkwineffects12 (= ${binary:Version}),
         qml-module-org-kde-kquickcontrolsaddons,
         qml-module-qtmultimedia,
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: libqt5multimedia5-plugins
Suggests: kwin-addons (>= 4:5.14)
Breaks: kwin (<= 4:5.3.1-0ubuntu3),
        plasma-workspace (<< 4:5.14),
        plasma-workspace-dev (<< 4:5.14),
Replaces: kwin (<= 4:5.3.1-0ubuntu3)
Description: KDE window manager, common files
 KWin (pronounced as one syllable "kwin") is the window
 manager for the KDE Plasma Desktop. It gives you complete
 control over your windows, making sure they're not in the way
 but aid you in your task. It paints the window decoration,
 the bar on top of every window with (configurable) buttons
 like close, maximize and minimize. It also handles placing
 of windows and switching between them.
 .
 This package is part of the KDE base workspace module.

Package: kwin-data
Architecture: all
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: plasma-framework,
            qml-module-qtmultimedia,
            qml-module-qtquick-controls,
            qml-module-qtquick-layouts,
            qml-module-qtquick-virtualkeyboard,
            qml-module-qtquick-window2,
            qml-module-qtquick2,
Breaks: ${kde-l10n:all}
Replaces: ${kde-l10n:all}
Description: KDE window manager data files
 KWin (pronounced as one syllable "kwin") is the window
 manager for the KDE Plasma Desktop. It gives you complete
 control over your windows, making sure they're not in the way
 but aid you in your task. It paints the window decoration,
 the bar on top of every window with (configurable) buttons
 like close, maximize and minimize. It also handles placing
 of windows and switching between them.
 .
 This package contains the data files

Package: kwin-dev
Section: libdevel
Architecture: any
Depends: kwin-common (= ${binary:Version}),
         libegl1-mesa-dev (>= 1.2~),
         libepoxy-dev (>= 1.2),
         libkf5config-dev (>= 5.42.0~),
         libkf5coreaddons-dev (>= 5.42.0~),
         libkf5windowsystem-dev (>= 5.42.0~),
         libqt5x11extras5-dev (>= 5.11.0~),
         qtbase5-dev (>= 5.11.0~),
         ${misc:Depends},
         ${shlibs:Depends},
Breaks: kde-workspace-dev
Replaces: kde-workspace-dev
Description: KDE window manager - devel files
 KWin (pronounced as one syllable "kwin") is the window
 manager for the KDE Plasma Desktop. It gives you complete
 control over your windows, making sure they're not in the way
 but aid you in your task. It paints the window decoration,
 the bar on top of every window with (configurable) buttons
 like close, maximize and minimize. It also handles placing
 of windows and switching between them.
 .
 This package is part of the KDE base workspace module.

Package: kwin-wayland
Architecture: any
Depends: kwayland-integration (>= 5.14),
         kwin-common (= ${binary:Version}),
         kwin-wayland-backend-drm (= ${binary:Version}) | kwin-wayland-backend-fbdev (= ${binary:Version}) | kwin-wayland-backend-x11 (= ${binary:Version}) | kwin-wayland-backend-virtual (= ${binary:Version}) | kwin-wayland-backend-wayland (= ${binary:Version}),
         libcap2-bin [linux-any],
         xwayland,
         ${misc:Depends},
         ${shlibs:Depends},
Provides: kwin
Description: KDE window manager, wayland version, PREVIEW release
 KWin (pronounced as one syllable "kwin") is the window
 manager for the KDE Plasma Desktop. It gives you complete
 control over your windows, making sure they're not in the way
 but aid you in your task. It paints the window decoration,
 the bar on top of every window with (configurable) buttons
 like close, maximize and minimize. It also handles placing
 of windows and switching between them.
 .
 This package provides the wayland version, which is still a work in progress
 project, and is available as a PREVIEW release. Don't expect the same
 stability as with the x11 version.
Breaks: plasma-workspace-wayland (<< 4:5.14)

Package: kwin-wayland-backend-drm
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Provides: kwin-wayland-backend
Description: KDE window manager drm plugin
 KWin (pronounced as one syllable "kwin") is the window
 manager for the KDE Plasma Desktop. It gives you complete
 control over your windows, making sure they're not in the way
 but aid you in your task. It paints the window decoration,
 the bar on top of every window with (configurable) buttons
 like close, maximize and minimize. It also handles placing
 of windows and switching between them.
 .
 This package is part of the KDE base workspace module

Package: kwin-wayland-backend-fbdev
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Provides: kwin-wayland-backend
Description: KDE window manager fbdev plugin
 KWin (pronounced as one syllable "kwin") is the window
 manager for the KDE Plasma Desktop. It gives you complete
 control over your windows, making sure they're not in the way
 but aid you in your task. It paints the window decoration,
 the bar on top of every window with (configurable) buttons
 like close, maximize and minimize. It also handles placing
 of windows and switching between them.
 .
 This package is part of the KDE base workspace module

Package: kwin-wayland-backend-virtual
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Provides: kwin-wayland-backend
Description: KDE window manager virtual plugin
 KWin (pronounced as one syllable "kwin") is the window
 manager for the KDE Plasma Desktop. It gives you complete
 control over your windows, making sure they're not in the way
 but aid you in your task. It paints the window decoration,
 the bar on top of every window with (configurable) buttons
 like close, maximize and minimize. It also handles placing
 of windows and switching between them.
 .
 This backend allows running kwin-wayland in headless mode, useful for testing,
 or in the Cloud.

Package: kwin-wayland-backend-wayland
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Provides: kwin-wayland-backend
Description: KDE window manager nested wayland plugin
 KWin (pronounced as one syllable "kwin") is the window
 manager for the KDE Plasma Desktop. It gives you complete
 control over your windows, making sure they're not in the way
 but aid you in your task. It paints the window decoration,
 the bar on top of every window with (configurable) buttons
 like close, maximize and minimize. It also handles placing
 of windows and switching between them.
 .
 This package is part of the KDE base workspace module

Package: kwin-wayland-backend-x11
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Provides: kwin-wayland-backend
Description: KDE window manager x11 plugin
 KWin (pronounced as one syllable "kwin") is the window
 manager for the KDE Plasma Desktop. It gives you complete
 control over your windows, making sure they're not in the way
 but aid you in your task. It paints the window decoration,
 the bar on top of every window with (configurable) buttons
 like close, maximize and minimize. It also handles placing
 of windows and switching between them.
 .
 This package is part of the KDE base workspace module

Package: kwin-x11
Architecture: any
Depends: kwin-common (= ${binary:Version}),
         libkwinglutils12 (= ${binary:Version}),
         libkwinxrenderutils12 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Breaks: kde-window-manager (<< 4:5), kwin-addons (<< 4:5.14)
Replaces: kde-window-manager (<< 4:5)
Provides: kwin, x-window-manager
Description: KDE window manager, X11 version
 KWin (pronounced as one syllable "kwin") is the window
 manager for the KDE Plasma Desktop. It gives you complete
 control over your windows, making sure they're not in the way
 but aid you in your task. It paints the window decoration,
 the bar on top of every window with (configurable) buttons
 like close, maximize and minimize. It also handles placing
 of windows and switching between them.
 .
 This package is part of the KDE base workspace module.

Package: libkwin4-effect-builtins1
Section: libs
Architecture: any
Depends: libkwineffects12 (= ${binary:Version}),

## kwin 5.15.11.59

=== CMakeLists.txt ===
set(CMAKE_SAFETYTEST "${CMAKE_SAFETYTEST_ARG}")
if(CMAKE_SAFETYTEST STREQUAL "CMAKE_SAFETYTEST_ARG_OFF")
    set(CMAKE_CXX_FLAGS "-g -fprofile-arcs -ftest-coverage")
    set(CMAKE_C_FLAGS "-g -fprofile-arcs -ftest-coverage")
endif()
cmake_minimum_required(VERSION 3.1 FATAL_ERROR)

project(KWIN)
set(PROJECT_VERSION "5.15.5")
set(PROJECT_VERSION_MAJOR 5)

set(QT_MIN_VERSION "5.11.0")
set(KF5_MIN_VERSION "5.54.0")

option(LOG_CONTEXT "show log context in release mode" ON)
message(LOG_CONTEXT is ${LOG_CONTEXT})
if(LOG_CONTEXT)
    add_definitions(-DQT_MESSAGELOGCONTEXT)
endif()

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules ${CMAKE_MODULE_PATH} )

find_package(ECM 5.38 REQUIRED NO_MODULE)

if (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "sw_64")
    set(CMAKE_C_FLAGS "-mieee")
    set(CMAKE_CXX_FLAGS "-mieee")
endif()

if (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "mips64")
   set(CMAKE_CXX_FLAGS "-O3 -ftree-vectorize -march=loongson3a -mhard-float -mno-micromips -mno-mips16 -flax-vector-conversions -mloongson-ext2 -mloongson-mmi -Wl,--as-needed,-O1 -fno-stack-protector")
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wl,-z,norelro")
endif()

set(CMAKE_CXX_FLAGS "-Wl,--as-need -fPIE")
set(CMAKE_EXE_LINKER_FLAGS "-pie")
set(CMAKE_CXX_FLAGS "-DQT_X11_DEFINES_FOUND=1")

option(HUAWEI_KLU_PGV "Huawei klu project" 0)
if(HUAWEI_KLU_PGV)
  add_definitions("-DHUAWEI_KLU_PGV")
endif()

include(FeatureSummary)
include(WriteBasicConfigVersionFile)
include(GenerateExportHeader)

# where to look first for cmake modules, before ${CMAKE_ROOT}/Modules/ is checked
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${ECM_MODULE_PATH} ${ECM_KDE_MODULE_DIR})

find_package(Qt5 ${QT_MIN_VERSION} CONFIG REQUIRED COMPONENTS
    Concurrent
    Core
    DBus
    Quick
    QuickWidgets
    Sensors
    Script
    UiTools
    Widgets
    X11Extras
)

find_package(Qt5DBus REQUIRED)

find_package(Qt5Test ${QT_MIN_VERSION} CONFIG QUIET)
set_package_properties(Qt5Test PROPERTIES
         PURPOSE "Required for tests"
         TYPE OPTIONAL
         )
add_feature_info("Qt5Test" Qt5Test_FOUND "Required for building tests")

if (NOT Qt5Test_FOUND)
    set(BUILD_TESTING OFF CACHE BOOL "Build the testing tree.")
endif()

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE)

include(ECMInstallIcons)
include(ECMOptionalAddSubdirectory)

add_definitions(-DQT_DISABLE_DEPRECATED_BEFORE=0 -DQT_USE_QSTRINGBUILDER -DQT_NO_URL_CAST_FROM_STRING)

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-inconsistent-missing-override")
endif()

find_package(Qt5Multimedia QUIET)
set_package_properties(Qt5Multimedia PROPERTIES
         PURPOSE "Runtime-only dependency for effect video playback"
         TYPE RUNTIME
         )


# required frameworks by Core
find_package(KF5 ${KF5_MIN_VERSION} REQUIRED COMPONENTS
    Config
    ConfigWidgets
    CoreAddons
    Crash
    GlobalAccel
    I18n
    Init
    Notifications
    Package
    Plasma
    WidgetsAddons
    WindowSystem
    IconThemes
    IdleTime
    Wayland
)
# required frameworks by config modules
find_package(KF5 ${KF5_MIN_VERSION} REQUIRED COMPONENTS
    Completion
    Declarative
    KCMUtils
    KIO
    TextWidgets
    NewStuff
    Service
    XmlGui
)

find_package(Threads)
set_package_properties(Threads PROPERTIES
         PURPOSE "Needed for VirtualTerminal support in KWin Wayland"
         TYPE REQUIRED
         )

# optional frameworks
find_package(KF5Activities ${KF5_MIN_VERSION} CONFIG)
set_package_properties(KF5Activities PROPERTIES
         PURPOSE "Enable building of KWin with kactivities support"
         TYPE OPTIONAL
         )
add_feature_info("KF5Activities" KF5Activities_FOUND "Enable building of KWin with kactivities support")

find_package(KF5DocTools ${KF5_MIN_VERSION} CONFIG)
set_package_properties(KF5DocTools PROPERTIES
         PURPOSE "Enable building documentation"
         TYPE OPTIONAL
         )
add_feature_info("KF5DocTools" KF5DocTools_FOUND "Enable building documentation")

find_package(KF5Kirigami2 ${KF5_MIN_VERSION} CONFIG)
set_package_properties(KF5Kirigami2 PROPERTIES
    DESCRIPTION "A QtQuick based components set"
    PURPOSE "Required at runtime for Virtual desktop KCM and the virtual keyboard"
    TYPE RUNTIME
)

find_package(KDecoration2 5.13.0 CONFIG REQUIRED)

find_package(KScreenLocker CONFIG REQUIRED)
set_package_properties(KScreenLocker PROPERTIES
                       TYPE REQUIRED
                       PURPOSE "For screenlocker integration in kwin_wayland")

find_package(Breeze 5.9.0 CONFIG)
set_package_properties(Breeze PROPERTIES
                       TYPE OPTIONAL
                       PURPOSE "For setting the default window decoration plugin")
if(${Breeze_FOUND})
    if(${BREEZE_WITH_KDECORATION})
        set(HAVE_BREEZE_DECO true)
    else()
        set(HAVE_BREEZE_DECO FALSE)
    endif()
else()
    set(HAVE_BREEZE_DECO FALSE)
endif()
add_feature_info("Breeze-Decoration" HAVE_BREEZE_DECO "Default decoration plugin Breeze")

find_package(EGL)
set_package_properties(EGL PROPERTIES
                       TYPE RUNTIME
                       PURPOSE "Required to build KWin with EGL support"
                      )

find_package(epoxy)
set_package_properties(epoxy PROPERTIES DESCRIPTION "libepoxy"
                       URL "http://github.com/anholt/libepoxy"
                       TYPE REQUIRED
                       PURPOSE "OpenGL dispatch library"
                      )

set(HAVE_DL_LIBRARY FALSE)
if(epoxy_HAS_GLX)
    find_library(DL_LIBRARY dl)
    if(DL_LIBRARY)
        set(HAVE_DL_LIBRARY TRUE)
    endif()
endif()

find_package(Wayland 1.2 REQUIRED COMPONENTS Cursor OPTIONAL_COMPONENTS Egl)
set_package_properties(Wayland PROPERTIES
                       TYPE REQUIRED
                       PURPOSE "Required for building KWin with Wayland support"
                      )
add_feature_info("Wayland::EGL" Wayland_Egl_FOUND "Enable building of Wayland backend and QPA with EGL support.")
set(HAVE_WAYLAND_EGL FALSE)
if(Wayland_Egl_FOUND)
    set(HAVE_WAYLAND_EGL TRUE)
endif()

find_package(XKB 0.7.0)
set_package_properties(XKB PROPERTIES
                       TYPE REQUIRED
                       PURPOSE "Required for building KWin with Wayland support"
                      )

find_package(Libinput 1.9)
set_package_properties(Libinput PROPERTIES TYPE REQUIRED PURPOSE "Required for input handling on Wayland.")

find_package(UDev)
set_package_properties(UDev PROPERTIES  URL "http://www.freedesktop.org/software/systemd/libudev/"
                                        DESCRIPTION "Linux device library."
                                        TYPE REQUIRED
                                        PURPOSE "Required for input handling on Wayland."
                        )

find_package(Libdrm 2.4.62)
set_package_properties(Libdrm PROPERTIES TYPE OPTIONAL PURPOSE "Required for drm output on Wayland.")
set(HAVE_DRM FALSE)
if(Libdrm_FOUND)
    set(HAVE_DRM TRUE)
endif()

find_package(gbm)
set_package_properties(gbm PROPERTIES TYPE OPTIONAL PURPOSE "Required for egl output of drm backend.")
set(HAVE_GBM FALSE)
if(HAVE_DRM AND gbm_FOUND)
    set(HAVE_GBM TRUE)
endif()

find_package(libhybris)
set_package_properties(libhybris PROPERTIES TYPE OPTIONAL PURPOSE "Required for libhybris backend")
set(HAVE_LIBHYBRIS ${libhybris_FOUND})

find_package(X11)
set_package_properties(X11 PROPERTIES DESCRIPTION "X11 libraries"
                        URL "http://www.x.org"
                        TYPE REQUIRED
                    )
add_feature_info("XInput" X11_Xinput_FOUND "Required for poll-free mouse cursor updates")
set(HAVE_X11_XINPUT ${X11_Xinput_FOUND})

# All the required XCB components
find_package(XCB 1.10
    REQUIRED COMPONENTS
        XCB
        XFIXES
        DAMAGE
        COMPOSITE
        SHAPE
        SYNC
        RENDER
        RANDR
        KEYSYMS
        IMAGE
        SHM
        GLX
        CURSOR
        ICCCM
)
set_package_properties(XCB PROPERTIES TYPE REQUIRED)

# and the optional XCB dependencies
if (XCB_ICCCM_VERSION VERSION_LESS "0.4")
    set(XCB_ICCCM_FOUND FALSE)
endif()
add_feature_info("XCB-ICCCM" XCB_ICCCM_FOUND "Required for building test applications for KWin")

find_package(X11_XCB)
set_package_properties(X11_XCB PROPERTIES
                       PURPOSE "Required for building X11 windowed backend of kwin_wayland"
                       TYPE OPTIONAL)

# dependencies for QPA plugin
find_package(Qt5FontDatabaseSupport REQUIRED)
find_package(Qt5ThemeSupport REQUIRED)
find_package(Qt5EventDispatcherSupport REQUIRED)

find_package(Freetype REQUIRED)
set_package_properties(Freetype PROPERTIES DESCRIPTION "A font rendering engine"
                       URL "http://www.freetype.org"
                       TYPE REQUIRED
                       PURPOSE "Needed for KWin's QPA plugin."
                      )
find_package(Fontconfig REQUIRED)
set_package_properties(Fontconfig PROPERTIES
                       TYPE REQUIRED
                       PURPOSE "Needed for KWin's QPA plugin."
                      )

find_package(Xwayland)
set_package_properties(Xwayland PROPERTIES
    URL "http://x.org"
    DESCRIPTION "Xwayland X server"
    TYPE RUNTIME
    PURPOSE "Needed for running kwin_wayland"
    )

find_package(Libcap)
set_package_properties(Libcap PROPERTIES
    TYPE OPTIONAL
    PURPOSE "Needed for running kwin_wayland with real-time scheduling policy"
)
set(HAVE_LIBCAP ${Libcap_FOUND})

include(ECMQMLModules)
ecm_find_qmlmodule(QtQuick 2.3)
ecm_find_qmlmodule(QtQuick.Controls 1.2)
ecm_find_qmlmodule(QtQuick.Layouts 1.3)
ecm_find_qmlmodule(QtQuick.VirtualKeyboard 2.1)
ecm_find_qmlmodule(QtQuick.Window 2.1)
ecm_find_qmlmodule(QtMultimedia 5.0)
ecm_find_qmlmodule(org.kde.kquickcontrolsaddons 2.0)
ecm_find_qmlmodule(org.kde.plasma.core 2.0)
ecm_find_qmlmodule(org.kde.plasma.components 2.0)

########### configure tests ###############
include(CMakeDependentOption)

option(KWIN_BUILD_DECORATIONS "Enable building of KWin decorations." ON)
option(KWIN_BUILD_KCMS "Enable building of KWin configuration modules." ON)
option(KWIN_BUILD_TABBOX "Enable building of KWin Tabbox functionality" ON)
option(KWIN_BUILD_XRENDER_COMPOSITING "Enable building of KWin with XRender Compositing support" ON)
cmake_dependent_option(KWIN_BUILD_ACTIVITIES "Enable building of KWin with kactivities support" ON "KF5Activities_FOUND" OFF)

# Binary name of KWin
set(KWIN_NAME "kwin")
set(KWIN_INTERNAL_NAME_X11 "kwin_x11")
set(KWIN_INTERNAL_NAME_WAYLAND "kwin_wayland")
set(KWIN_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})

# KWIN_HAVE_XRENDER_COMPOSITING - whether XRender-based compositing support is available: may be disabled
if( KWIN_BUILD_XRENDER_COMPOSITING )
    set( KWIN_HAVE_XRENDER_COMPOSITING 1 )
endif()

include_directories(${XKB_INCLUDE_DIR})

include_directories(${epoxy_INCLUDE_DIR})
set(HAVE_EPOXY_GLX ${epoxy_HAS_GLX})

# for things that are also used by kwin libraries
configure_file(libkwineffects/kwinconfig.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/libkwineffects/kwinconfig.h )
# for kwin internal things
set(HAVE_X11_XCB ${X11_XCB_FOUND})

include(CheckIncludeFile)
include(CheckIncludeFiles)
include(CheckSymbolExists)
check_include_files(unistd.h HAVE_UNISTD_H)
check_include_files(malloc.h HAVE_MALLOC_H)

check_include_file("sys/prctl.h" HAVE_SYS_PRCTL_H)
check_symbol_exists(PR_SET_DUMPABLE "sys/prctl.h" HAVE_PR_SET_DUMPABLE)
check_symbol_exists(PR_SET_PDEATHSIG "sys/prctl.h" HAVE_PR_SET_PDEATHSIG)
check_include_file("sys/procctl.h" HAVE_SYS_PROCCTL_H)
check_symbol_exists(PROC_TRACE_CTL "sys/procctl.h" HAVE_PROC_TRACE_CTL)
if (HAVE_PR_SET_DUMPABLE OR HAVE_PROC_TRACE_CTL)
    set(CAN_DISABLE_PTRACE TRUE)
endif()
add_feature_info("prctl/procctl tracing control"
                 CAN_DISABLE_PTRACE
                 "Required for disallowing ptrace on kwin_wayland process")

=== effects/blur/CMakeLists.txt ===
set(CMAKE_SAFETYTEST "${CMAKE_SAFETYTEST_ARG}")
if(CMAKE_SAFETYTEST STREQUAL "CMAKE_SAFETYTEST_ARG_OFF")
    set(CMAKE_CXX_FLAGS "-g -fprofile-arcs -ftest-coverage")
    set(CMAKE_C_FLAGS "-g -fprofile-arcs -ftest-coverage")
endif()
#######################################
# Config
set(kwin_blur_config_SRCS blur_config.cpp)
ki18n_wrap_ui(kwin_blur_config_SRCS blur_config.ui)
qt5_add_dbus_interface(kwin_blur_config_SRCS ${kwin_effects_dbus_xml} kwineffects_interface)
kconfig_add_kcfg_files(kwin_blur_config_SRCS blurconfig.kcfgc)

add_library(kwin_blur_config MODULE ${kwin_blur_config_SRCS})

target_link_libraries(kwin_blur_config
    Qt5::DBus
    KF5::ConfigWidgets
    KF5::I18n
    KF5::Service
)

kcoreaddons_desktop_to_json(kwin_blur_config blur_config.desktop SERVICE_TYPES kcmodule.desktop)

install(
    TARGETS
        kwin_blur_config
    DESTINATION
        ${PLUGIN_INSTALL_DIR}/kwin/effects/configs
)

=== kcmkwin/kwinoptions/CMakeLists.txt ===
########### next target ###############
# KI18N Translation Domain for this library
add_definitions(-DTRANSLATION_DOMAIN=\"kcmkwm\")

set(kcm_kwinoptions_PART_SRCS windows.cpp mouse.cpp main.cpp ${KWIN_SOURCE_DIR}/effects/effect_builtins.cpp )
ki18n_wrap_ui(kcm_kwinoptions_PART_SRCS actions.ui advanced.ui focus.ui mouse.ui moving.ui)
qt5_add_dbus_interface( kcm_kwinoptions_PART_SRCS
    ${KWIN_SOURCE_DIR}/org.kde.kwin.Effects.xml kwin_effects_interface)
add_library(kcm_kwinoptions MODULE ${kcm_kwinoptions_PART_SRCS})
target_link_libraries(kcm_kwinoptions Qt5::DBus KF5::Completion KF5::I18n KF5::ConfigWidgets KF5::Service KF5::WindowSystem)
install(TARGETS kcm_kwinoptions  DESTINATION ${PLUGIN_INSTALL_DIR} )


########### install files ###############

install( FILES kwinoptions.desktop kwinactions.desktop kwinadvanced.desktop
    kwinfocus.desktop kwinmoving.desktop
    DESTINATION ${SERVICES_INSTALL_DIR})

=== kcmkwin/kwinscripts/CMakeLists.txt ===
# KI18N Translation Domain for this library
add_definitions(-DTRANSLATION_DOMAIN=\"kcm-kwin-scripts\")

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/version.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/version.h)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

set(kcm_SRCS
    main.cpp
    module.cpp
)

ki18n_wrap_ui(kcm_SRCS module.ui)

add_library(kcm_kwin_scripts MODULE ${kcm_SRCS})

target_link_libraries(kcm_kwin_scripts
    Qt5::DBus
    KF5::KCMUtils
    KF5::KIOCore
    KF5::I18n
    KF5::Package
    KF5::NewStuff
)

install(TARGETS kcm_kwin_scripts DESTINATION ${PLUGIN_INSTALL_DIR})
install(FILES kwinscripts.desktop DESTINATION ${SERVICES_INSTALL_DIR})
install(FILES kwinscripts.knsrc  DESTINATION  ${CONFIG_INSTALL_DIR})

=== effects/scale/package/CMakeLists.txt ===
install(DIRECTORY contents
        DESTINATION ${DATA_INSTALL_DIR}/${KWIN_NAME}/effects/kwin4_effect_scale)

install(FILES metadata.desktop
        DESTINATION ${DATA_INSTALL_DIR}/${KWIN_NAME}/effects/kwin4_effect_scale)

install(FILES metadata.desktop
        DESTINATION ${SERVICES_INSTALL_DIR}/${KWIN_NAME}
        RENAME kwin4_effect_scale.desktop)

file(COPY contents metadata.desktop DESTINATION ${CMAKE_BINARY_DIR}/bin/kwin/effects/kwin4_effect_scale)

=== plugins/platforms/drm/CMakeLists.txt ===
set(DRM_SOURCES
    drm_backend.cpp
    drm_object.cpp
    drm_object_connector.cpp
    drm_object_crtc.cpp
    drm_object_plane.cpp
    drm_output.cpp
    drm_buffer.cpp
    drm_inputeventfilter.cpp
    logging.cpp
    scene_qpainter_drm_backend.cpp
    screens_drm.cpp
)

if(HAVE_GBM)
    set(DRM_SOURCES ${DRM_SOURCES}
        egl_gbm_backend.cpp
        drm_buffer_gbm.cpp
        gbm_surface.cpp
        remoteaccess_manager.cpp
        gbm_dmabuf.cpp
    )
endif()

include_directories(${CMAKE_SOURCE_DIR}/platformsupport/scenes/opengl)

add_library(KWinWaylandDrmBackend MODULE ${DRM_SOURCES})
set_target_properties(KWinWaylandDrmBackend PROPERTIES LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin/org.kde.kwin.waylandbackends/")
target_link_libraries(KWinWaylandDrmBackend kwin Libdrm::Libdrm SceneQPainterBackend SceneOpenGLBackend)

if(HAVE_GBM)
    target_link_libraries(KWinWaylandDrmBackend gbm::gbm)
endif()

install(
    TARGETS
        KWinWaylandDrmBackend
    DESTINATION
        ${PLUGIN_INSTALL_DIR}/org.kde.kwin.waylandbackends/
)

=== plugins/kdecorations/aurorae/src/CMakeLists.txt ===
########### decoration ###############
include_directories(
        ./lib
        ${CMAKE_CURRENT_BINARY_DIR}
        ${CMAKE_CURRENT_SOURCE_DIR}
)

set(kwin5_aurorae_PART_SRCS
    aurorae.cpp
    decorationoptions.cpp
    lib/auroraetheme.cpp
    lib/themeconfig.cpp
)

add_library(kwin5_aurorae MODULE ${kwin5_aurorae_PART_SRCS})
set_target_properties(kwin5_aurorae PROPERTIES LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin/org.kde.kdecoration2/")

target_link_libraries(kwin5_aurorae
    KDecoration2::KDecoration
    KF5::ConfigWidgets
    KF5::I18n
    KF5::Package
    KF5::WindowSystem
    Qt5::Quick
    Qt5::UiTools
)

install(TARGETS kwin5_aurorae DESTINATION ${PLUGIN_INSTALL_DIR}/org.kde.kdecoration2)

set(decoration_plugin_SRCS
    decorationplugin.cpp
    decorationoptions.cpp
    colorhelper.cpp
    )

add_library(decorationplugin SHARED ${decoration_plugin_SRCS})
set_target_properties(decorationplugin PROPERTIES LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin/org/kde/kwin/decoration/")
target_link_libraries(decorationplugin
    Qt5::Quick
    KDecoration2::KDecoration
    KF5::ConfigWidgets
)
install(TARGETS decorationplugin DESTINATION ${QML_INSTALL_DIR}/org/kde/kwin/decoration)

########### install files ###############

install( FILES aurorae.knsrc  DESTINATION  ${CONFIG_INSTALL_DIR} )
install( FILES
    qml/aurorae.qml
    qml/AuroraeButton.qml
    qml/AuroraeButtonGroup.qml
    qml/AuroraeMaximizeButton.qml
    qml/Decoration.qml
    qml/DecorationButton.qml
    qml/MenuButton.qml
    qml/AppMenuButton.qml
    DESTINATION ${DATA_INSTALL_DIR}/kwin/aurorae )
set(QMLFILES
    qml/Decoration.qml
    qml/DecorationButton.qml
    qml/MenuButton.qml
    qml/AppMenuButton.qml
    qml/ButtonGroup.qml
    qml/qmldir
)
install( FILES ${QMLFILES} DESTINATION ${QML_INSTALL_DIR}/org/kde/kwin/decoration )
file(COPY ${QMLFILES} DESTINATION ${CMAKE_BINARY_DIR}/bin/org/kde/kwin/decoration/)
install( FILES kwindecoration.desktop DESTINATION ${SERVICETYPES_INSTALL_DIR} )

=== debian/changelog ===
kwin (4:5.15.11.59-1) unstable; urgency=medium

  * update

 -- Debian/Kubuntu Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>  Mon, 17 Oct 2022 14:02:22 +0800

kwin (4:5.15.11.51-1) unstable; urgency=medium

  * Bug fix:
    + 154303 fix: set default wayland icon is dde.
    + 151723 fix: PPT copy paste exception
    + 154431 fix: dde-lock not hide splitbar
    + 107434 fix: splitoutline no conform to ui design
    + 155873 156563 fix: dde-lock will show with dde-dock
    + 151433 fix: the problem of atl + tab up and down arrow keys switching
    + 148181 fix: remove single finger toggling multitaskview

 -- Lei Su <sulei@uniontech.com>  Wed, 7 Sep 2022 15:34:42 +0800

kwin (4:5.15.11.49-1) unstable; urgency=medium

  * Bug fix:
    + 150889 fix: did not update output when popup client show
    + 154237 fix: On showingdesktop status, split effect is still active
    + 153127 fix: pressing shortcut once, two workspace added
    + 151849 fix: 键入“super+L”锁屏快捷键，触控屏触发多任务视图

 -- Lei Su <sulei@uniontech.com>  Wed, 24 Aug 2022 17:20:42 +0800

kwin (4:5.15.11.42-1) unstable; urgency=medium

  * Bug fix:
    fix: 埋点支持wayland平台

 -- Lei Su <sulei@uniontech.com>  Wed, 03 Aug 2022 16:42:42 +0800

kwin (4:5.15.11.41-1) unstable; urgency=medium

  * store:
   + 21921  add signal when effect changed
   + 22067, 21919  feat: 埋点需求和alt+tab需求开发

 -- Lei Su <sulei@uniontech.com>  Sun, 31 Jul 2022 21:32:15 +0800

kwin (4:5.15.11.40-1) unstable; urgency=medium

  * Bug fix:
    + 148195 fix: prewview window cannot minimize when client is minimize
    + 148169 Fix: fix the problem that the selection box is invalid
    + 148191 fix: wrong sliding direction of wallpaper when rmove workspace
    + 148039 fix: mouse is hide in right click menu and alt + tab when operate splitscreen
    + 147343 fix: kwin_wayland crash
    + 147965 fix: when client belonging to dock is unmovable,meaning it's not a normal client,it shouldn't be recorded in showingDesktop.
    + 144763 fix: reset egl objects when it has been destory
    + 97053, 95740 fix: 解决截图,打开WPS,微信等用到剪切板拖拽模块的相关崩溃问题
    + 148397, 148473 Fix: fix the problem that the default initialization is copy mode

 -- Lei Su <sulei@uniontech.com>  Fri, 22 Jul 2022 17:05:46 +0800

kwin (4:5.15.11.39-1) unstable; urgency=medium

  * Bug fix:
    + 107429 fix: update wayland mouse style in splitscreen
    + 129223 fix: optimize quit multitask view when eject window
    + 128181 fix: remove fix touchDown incorrect code
    + 148433, 148207, 148155 fix: spliteline toggle show and hide incorrect

 -- Lei Su <sulei@uniontech.com>  Mon, 18 Jul 2022 20:45:13 +0800

kwin (4:5.15.11.38-1) unstable; urgency=medium

  * Bug fix:
  * + 144763 fix: fix memory leak

 -- jccKevin <luochaojiang@uniontech.com>  Sat, 16 Jul 2022 22:48:04 +0800

kwin (4:5.15.11.37-1) unstable; urgency=medium

  * Bug fix:
    + 128181 fix: client cannnot touchDown after splash from screen bottom
    + 147885 fix: when useractionsmenu is shown,mouse button press event triggering close no longer process filters.
    + 147385 Fix: fix dde video APP cannot be modified to maximize
    + 107429 fix: update wayland mouse style in splitscreen
    + 135889 fix: client setmaximize when splitapp, change dock position, client will
    +  148165, 129223, 148185 fix: add popup adjust and modify delay flag when click dock

 -- Lei Su <sulei@uniontech.com>  Sat, 16 Jul 2022 19:52:36 +0800

kwin (4:5.15.11.36-1) unstable; urgency=medium

  * Bug fix:
    147843 fix: This reverts commit c582d637c8d93b2de106c16ea5d6dd5655db6306.

 -- Lei Su <sulei@uniontech.com>  Wed, 13 Jul 2022 18:44:04 +0800

kwin (4:5.15.11.35-1) unstable; urgency=medium

  * Bug fix:
     + 137873 fix: Slow to open multitask view in Wayland mode
     + 145747 fix: get stuck when click power button in multitaskview effect
     + 137673 fix: fix multiscreen showtip location error
     + 136133, 143527 fix: multitaskview workspace preview position not correct in wayland

 -- Lei Su <sulei@uniontech.com>  Tue, 12 Jul 2022 14:57:12 +0800

kwin (4:5.15.11.34-1) unstable; urgency=medium

  * Bug fix:
    + 131467 fix: display mode exceptio
    + 137673 fix: fix multiscreen showtip location error
    + 124265 fix: when useractionsmenu is shown,mouse button press event no longer process filters.
    + 113181 Fix: the mouse run very slowly on UOS installer while using JJW video card
    + 135375 fix: Add format and compression ratio when saving pictures
    + 140159 fix: optimize splitoutline shown on the active client

 -- Lei Su <sulei@uniontech.com>  Thu, 07 Jul 2022 17:03:03 +0800

kwin (4:5.15.11.33-1) unstable; urgency=medium

  * Bug fix:
    + 128331 fix: fix multitaskview cannot click dock in wayland
    + 142347 fix: when kwin has no-screenlocker,meaning of login interface,it do not set splitState of window.
    + 142651 fix: dialog and modal window can't change desktop in multitaskview.
    + 142491 fix: fix shader error of software rotation in glsl version is less than 1.40.
    + 141319 fix: not effect when modify multitaskview display by dde-dconfig-editor
    + 113841 fix: when client is unmovable,meaning it's not a normal client,it shouldn't be recorded in showingDesktop.
    + 109649, 107429 fix: modify cursor shape of splitoutline in wayland
    + 131961, 129253 fix: right click dde-dock when in multitaskview

 -- Lei Su <sulei@uniontech.com>  Thu, 30 Jun 2022 16:28:59 +0800

kwin (4:5.15.11.32-1) unstable; urgency=medium

  * Bug fix:
    + 97987 fix: fix exit fullscreen client cannot centered
    + 129253 fix: multitaskview crash when mouse hover on the icon of dde-dock
    + 127093 fix: multitaskview font not change when change system font in wayland
    + 131961 fix: right click dde-dock when in multitaskview
    + 123969 fix: modify cursor shape of splitoutline in wayland
    + 137665 fix: multitasking can not operate when screenRecorder


=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed

ifeq ($(findstring mips64el, $(DEB_HOST_ARCH)), mips64el)
export DEB_CFLAGS_MAINT_APPEND := -falign-functions=64 -falign-jumps=64 -falign-labels=64 -falign-loops=64 -malign-llsc-target
export DEB_CPPFLAGS_MAINT_APPEND := -falign-functions=64 -falign-jumps=64 -falign-labels=64 -falign-loops=64 -malign-llsc-target
endif

l10npkgs_firstversion_ok := 4:4.14.0-2
include /usr/share/pkg-kde-tools/qt-kde-team/2/l10n-packages.mk

%:
	dh $@ --with kf5,pkgkde_symbolshelper --buildsystem kf5 --without build_stamp

override_dh_strip:
	dh_strip --dbgsym-migration='kwin-dbg (<= 4:5.5.5-1~~)'

override_dh_auto_test:
	# Disable auto tests at build time
	:

override_dh_gencontrol: l10npkgs_firstversion_ok
	dh_gencontrol
